structure Main :
sig
	val main: string * string list -> OS.Process.status
end =
struct
	fun complain (p, s) =
		(TextIO.output (TextIO.stdErr, concat [p, ": ", s, "\n"]);
		 OS.Process.failure)

	fun main (p, [inf, outf]) =
		((JSONPrinter.print' { strm = TextIO.openOut outf, pretty = true }
				  (JSONParser.parseFile inf);
		  OS.Process.success)
		 handle e => complain (p, "exception: " ^ General.exnMessage e))
	  | main (p, _) = complain (p, "usage: " ^ p ^ " infile.json outfile.json")
end
